//+------------------------------------------------------------------+
//|                                                     swb-GRID.mq4 |
//|                              Copyright  2009, Totom Sukopratomo |
//|                                     mailto:forexengine@gmail.com |
//|           Hasil perkawinan swbAmtwoxtwo & indrafxscalping v 4.02 |
//|                   sori kalau codingnya jadi jauh banget bedanya, |
//|                                      maklum masih noobydooby.... |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Totom Sukopratomo"
#property link      "mailto:forexengine@gmail.com"

//---- input parameters
int magic=1;
extern int       TargetBalance=10000000;
extern int       JamMulaiTrade=13;
extern int       JamSelesaiTrade=20;
extern int       MaxSpread=10; //cuma berlaku di level 1, kalau dilevel berikutnya harus tetap open walaupun spreadnya segedhe gajah....mau loss?
extern int       Slippage=3;
extern double    initial_lot=0.1;
extern int       grid_level=10;
extern int       range=20;
extern double    multiplier=2;
extern bool      EquityProfitClose=true;
extern double    HowManyBucks=100;
extern int       TakeProfit=10;
extern string    note=".: Parameter Indikator :.";
extern bool      UseMA = false;
extern int       PeriodMA=5;
extern string    note_0="MA Method: 0=Simple, 1=Exponential, 2=Smoothed, 3=Linear Weighted";
extern int       maMethod=1;
extern bool      UseBollinger=true;
extern int       PeriodsBB=20;
extern int       Shift=0;
extern int       Deviations=2;
extern bool      UseStochastic=true;
extern int       Kperiod=5;
extern int       Dperiod=3;
extern int       Slowing=3;
extern string    oo="PriceField.. 0= Low/High , 1=Close/Close";
extern int       PriceField=0;
extern int       StochMAMethod=0;
extern int       HighStoch=85;
extern int       LowStoch=15;
       int prec, jumlah, hitung;
       double pt, minlot, maxlot, startbalance;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   if(Digits<4) pt=0.01;
   else         pt=0.0001;
   minlot=MarketInfo(Symbol(), MODE_MINLOT);
   maxlot=MarketInfo(Symbol(), MODE_MAXLOT);
   if(minlot==0.01)     prec=2;
   else if(minlot==0.1) prec=1;
   else                 prec=0;
   startbalance=AccountBalance();
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if(AccountBalance()>TargetBalance)
   {
      closeall();
      Comment("\nTARGET BALANCE IS REACHED !!!");
      return(0);
   }
//----
   if(EquityProfitClose && AccountEquity()>startbalance+HowManyBucks) 
     {
       if(closeall()>0 && jumlah()==0) startbalance=AccountBalance();
     }
//----
   int tutup=0;
   if(OrdersTotal()>0)
   {
      for(hitung=0; hitung<OrdersTotal(); hitung++)
      {
          OrderSelect(hitung, SELECT_BY_POS, MODE_TRADES);
          if(OrderSymbol()!=Symbol()) continue;
          if(OrderComment()=="main order")
          {
             if(OrderType()==OP_BUY)
             {
                if(Bid>OrderOpenPrice()+TakeProfit*pt)
                {
                   tutup++;
                }
             }
             if(OrderType()==OP_SELL)
             {
                if(Ask<OrderOpenPrice()-TakeProfit*pt)
                {
                   tutup++;
                }
             }
          }
      }
   }
   if(tutup>0) closeall();
//----
   if(TimeHour(TimeCurrent())>=JamSelesaiTrade || TimeHour(TimeCurrent())<JamMulaiTrade)
   {
      Comment("\nBelum waktunya trading....");
      return(0);
   }
   Comment("");
//----
   double ma1=iMA(Symbol(),0,PeriodMA,0,maMethod,PRICE_CLOSE,1);
   double ma2=iMA(Symbol(),0,PeriodMA,0,maMethod,PRICE_OPEN,1);
   double bb1=iCustom(Symbol(),0,"Bands",PeriodsBB,Shift,Deviations,1,0);
   double bb2=iCustom(Symbol(),0,"Bands",PeriodsBB,Shift,Deviations,2,0);
   double stoch=iStochastic(Symbol(),0,Kperiod,Dperiod,Slowing,PriceField,StochMAMethod,MODE_SIGNAL,0);
//----
   int BUY=0, SELL=0, Buy=0, Sell=0, buy=0, sell=0;
   if(ma1>ma2)           BUY++;
   if(ma1<ma2)           SELL++;
   if(Close[0]<bb2)  Buy++;
   if(Close[0]>bb1)  Sell++;
   if(stoch<LowStoch)    buy++;
   if(stoch>HighStoch)   sell++;
   bool long, short;
   if(UseMA && !UseBollinger && !UseStochastic)
   {
      if(BUY>0)    long=TRUE;
      else         long=FALSE;
      if(SELL>0)   short=TRUE; 
      else         short=FALSE;
   }
   if(!UseMA && UseBollinger && !UseStochastic)
   {
      if(Buy>0)    long=TRUE;
      else         long=FALSE;
      if(Sell>0)   short=TRUE;
      else         short=FALSE;
   }
   if(!UseMA && !UseBollinger && UseStochastic)
   {
      if(buy>0)    long=TRUE;
      else         long=FALSE;
      if(sell>0)   short=TRUE;
      else         short=FALSE;
   }
   if(UseMA && UseBollinger && !UseStochastic)
   {
      if(BUY>0 && Buy>0)    long=TRUE;
      else                  long=FALSE;
      if(SELL>0 && Sell>0)  short=TRUE;
      else                  short=FALSE;
   }
   if(!UseMA && UseBollinger && UseStochastic)
   {
      if(Buy>0 && buy>0)    long=TRUE;
      else                  long=FALSE;
      if(Sell>0 && sell>0)  short=TRUE;
      else                  short=FALSE;
   }
   if(UseMA && !UseBollinger && UseStochastic)
   {
      if(BUY>0 && buy>0)    long=TRUE;
      else                  long=FALSE;
      if(SELL>0 && sell>0)  short=TRUE;
      else                  short=FALSE;
   }
   if(UseMA && UseBollinger && UseStochastic)
   {
      if(BUY>0 && Buy>0 && buy>0)     long=TRUE;
      else                            long=FALSE;
      if(SELL>0 && Sell>0 && sell>0)  short=TRUE;
      else                            short=FALSE;
   }
   if(!UseMA && !UseBollinger && !UseStochastic)
   {
     Comment("\nPakai minimal 1 indicator !!............",
             "\nSoalnya ga bisa trading tanpa indicator.");
     return(0);
   }
//----
   if(jumlah()==0)
   {
      if(long==TRUE && MarketInfo(Symbol(), MODE_SPREAD)<MaxSpread)  {if(sendorder(0,initial_lot,magic, "main order")) return(0);}
      if(short==TRUE && MarketInfo(Symbol(), MODE_SPREAD)<MaxSpread) {if(sendorder(1,initial_lot,magic, "main order")) return(0);}
   }
   double op=0,lot=0; 
   int type=-1;
   if(jumlah()>0 && jumlah()<grid_level)
   {
      for(hitung=0; hitung<OrdersTotal(); hitung++)
      {
          if(!OrderSelect(hitung, SELECT_BY_POS, MODE_TRADES)) break;
          if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic) continue;
          op=OrderOpenPrice();
          type=OrderType();
          lot=OrderLots();
      }
      if(type==0)
      {
         if(Ask<op-range*pt)  {if(sendorder(0, NormalizeDouble(lot*multiplier, prec), magic, "grid")) return(0);}
      }
      if(type==1)  
      {
         if(Bid>op+range*pt)  {if(sendorder(1, NormalizeDouble(lot*multiplier, prec), magic, "grid")) return(0);}
      }
   }
   return(0);
  }
//+------------------------------------------------------------------+
int jumlah()
  { 
   jumlah=0;
   for(hitung=0; hitung<OrdersTotal(); hitung++)
   {
      OrderSelect(hitung, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic) continue;
      jumlah++;
   } 
   return(jumlah);
  } 
//+------------------------------------------------------------------+
bool sendorder(int cmd, double mylot, int orderID, string cmnt) 
  {
   double LOT=0;
   if(mylot<minlot)       LOT=minlot;
   else if(mylot>maxlot)  LOT=maxlot;
   else                   LOT=mylot;
   if(cmd==0) 
   {
      if(OrderSend(Symbol(), 0, LOT, Ask, Slippage, 0, 0, cmnt, orderID, 0, Blue)>0) return(true);
      if(GetLastError()==138) RefreshRates();
   }
   if(cmd==1) 
   {
      if(OrderSend(Symbol(), 1, LOT, Bid, Slippage, 0, 0, cmnt, orderID, 0, Red)>0) return(true);
      if(GetLastError()==138) RefreshRates();
   }
   return(false);
  }
//+------------------------------------------------------------------+
int closeall()
  {
    int tutup=0;
    for(hitung=OrdersTotal()-1; hitung>=0; hitung--)
    {
        if(!OrderSelect(hitung, SELECT_BY_POS, MODE_TRADES)) break;
        if(OrderSymbol()!=Symbol()) continue;
        if(OrderMagicNumber()==magic)
        {
           if(OrderType()==OP_BUY)  
           {
              if(OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, Magenta)) tutup++;
           }
           if(OrderType()==OP_SELL) 
           {
              if(OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, Magenta)) tutup++;
           }
        }
    }
    return(tutup);
  }
               